// searchdb.h
// 6/7/99
// Linear structure for demo of searching ordered and unordered sequence
// Ken Brownsey

#include "my_const.h"
#include "sequence.h"

typedef Sequence_T SearchDB_T;


//	PRE	Q_Full(DB) is FALSE
//       AND keys in DB are in order
// POST	DB' = DB with NewRec added
//       AND keys in DB' are in order
void
Add_Value(int Value, SearchDB_T DB);


//	PRE	Size > 0
// POST	UnOrdRandDB contains Size distinct
//			integers in the range 1..MaxVal
//			in random order
void
Make_UnOrdered_RandomDB(SearchDB_T UnOrdRandDB, int Size, int &MaxVal);


//	PRE	TRUE
//	POST 	Q_Empty(DB)
void
Make_Empty(SearchDB_T DB);


//	PRE	Num > 0
//	POST	RETURNS number of digits in Num
int
Find_NumDigits(int Num);

//	PRE	TRUE
//	POST	RETURNS number of elements in DB
int
Get_Size(SearchDB_T DB);

