// Ken Brownsey
// 31/8/98
// bst_tree.h
// BST_T
#include "rec_tree.h"

typedef BT_T BST_T;

// PRE	TRUE
// POST	IF Rec is in BST
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_BST_Present_R(Key_T Key, BST_T BST);

// PRE	NOT Q_BST_Present_R(Rec, BST)
// POST	RETURNS BST with Rec inserted
BST_T
BST_Insert_R(Element_T Rec, BST_T BST);


// PRE	Q_BST_Present_R(Key, BST)
// POST	returnS record with key value Key from BST
Element_T
BST_Retrieve_R(Key_T Key, BST_T BST);


// PRE	TRUE
// POST	if (Q_BST_Present(Rec, BST)
//				returnS BST with Rec deleted
//			ELSE
//				returnS BST
BST_T
BST_Delete_R(Key_T Key, BST_T BST);


// PRE	NOT Q_EmptyTree(BST)
// POST	returnS rightmost Element_T of BST
Element_T
Get_RightMost_R(BST_T BST);
