// data.cpp
// 24/7/98
// data for binary search tree demo
// Ken Brownsey

#include "data.h"
#include <iostream.h>
#include "rd_str.h"
#include <string.h>

// PRE	TRUE
// POST	user is prompted for student key value which is returned
Number_T
Read_Number() {
	Number_T Number;

	cin	>>	Number;
	return(Number);
}


// PRE	TRUE
// POST	key value is written to screen
void
Write_Number(Number_T Number) {

	cout	<< Number;
}


// PRE	TRUE
// POST	returnS key value of Rec
Number_T
Get_Number(DataRec_T DataRec) {

	return(DataRec.Number);
}


// PRE	TRUE
// POST	returnS Name value of Rec
char
*Get_Name(DataRec_T DataRec) {

	return(DataRec.Name);
}


//	PRE	TRUE
//	POST	prompts user for DDMMYY date
//			which is read into Date
void
Read_Date(Date_T &Date) {

	cout	<<	"Day ==> ";
	cin	>>	Date.Day;
	cout	<<	"Month ==> ";
	cin	>>	Date.Month;
	cout	<<	"Year ==> ";
	cin	>>	Date.Year;
}


//	PRE	TRUE
//	POST	writes Rec to screen
void
Write_Date(Date_T Date) {

	cout	<<	Date.Day
			<< "\\"
			<<	Date.Month
			<< "\\"
			<<	Date.Year;
}



//	PRE	TRUE
//	POST	RETURNS Date from DataRec
Date_T
Get_Date(DataRec_T DataRec) {
	return(DataRec.Date);
}


// PRE	TRUE
// POST	Prompts user for club by number
//		and returns mode club in defaulting to NoClub */
Club_T
Read_Club() {
	int	InData;
	Club_T Result;

	cout	<< "\nDiogenes please enter 1 ";
	cout	<< "\nDrones please enter 2 ";
	cout	<< "\nRunagates please enter 3 ";
	cout	<< "\nHell Fire please enter 4 ";
	cout	<< "\nTufty please enter 5 ";
	cout	<< "\n ====>  ";
	cin	>> InData;
	switch (InData) {

		case 1:
			Result = Diogenes;
		break;
		case 2:
			Result = Drones;
		break;
		case 3:
			Result = Runagates;
		break;
		case 4:
			Result = HellFire;
		break;
		case 5:
			Result = Tufty;
		break;
		default:
			Result = NoClub;
		break;
	}
	return(Result);
}


//	PRE	TRUE
//	POST	IF Club is valid
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
Q_ValidClub(Club_T Club) {

	return(Club != NoClub);
}


//	PRE	TRUE
//	POST	IF Club has a TRUE entry in Clubs
//				RETURNS(TRUE)
//			ELSE
//				RETURNS(FALSE)
BOOLEAN
Q_Member_Of_Club(Club_T Club, DataRec_T Rec) {
	return(Rec.Clubs[Club]);
}


//	PRE	Club != NoClub
//	POST	Club has a TRUE entry in Clubs filed of Record
void
Set_Club(Club_T Club, DataRec_T &Record) {
	Record.Clubs[Club] = TRUE;
}


//	PRE	Club != NoClub
//	POST	Club has a FALSE entry in Clubs field of Record
void
UnSet_Club(Club_T Club, DataRec_T &Record) {
	Record.Clubs[Club] = FALSE;
}


// PRE	Club has a valid value
// POST	Prints string for Club
void
Write_Club(Club_T Club) {
	switch(Club) {

		case Diogenes:
			cout << "Diogenes";
		break;
		case Drones:
			cout	<< "Drones";
		break;
		case Runagates:
			cout	<< "Runagates";
		break;
		case HellFire:
			cout	<< "Hell Fire";
		break;
		case Tufty:
			cout	<< "Tufty";
		break;
		default:
		break;
	}
}


//	PRE	TRUE
//	POST	All members of Clubs which have TRUE entries are printed
void
Write_Clubs(Clubs_T Clubs) {
	int	Club;

	for(Club = Diogenes; Club < NumClubs; Club++) {
		if (Clubs[Club]) {
			Write_Club(Club);
			cout	<< "  ";
		}
	}
}



//	PRE	TRUE
// POST	IF Date1 precedes Date2
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_Date_Before(Date_T	Date1, Date_T	Date2) {
	if (Date1.Year < Date2.Year) {
		return(TRUE);
	}
	if (Date1.Year > Date2.Year) {
		return(FALSE);
	}
	// Date1.Year == Date2.Year
	if (Date1.Month < Date2.Month) {
		return(TRUE);
	}
	if (Date1.Month > Date2.Month) {
		return(FALSE);
	}
	// Date1.Month == Date2.Month
	if (Date1.Day < Date2.Day) {
		return(TRUE);
	}
	if (Date1.Day >= Date2.Day) {
		return(FALSE);
	}
}


//	PRE	TRUE
// POST	IF Date1 equals Date2
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_Dates_Equal(Date_T	Date1, Date_T	Date2) {
	if (Date1.Year != Date2.Year) {
		return(FALSE);
	}
	// Date1.Year == Date2.Year
	if (Date1.Month != Date2.Month) {
		return(FALSE);
	}
	// Date1.Month == Date2.Month
	if (Date1.Day != Date2.Day) {
		return(FALSE);
	}
	return(TRUE);
}

//	PRE	TRUE
//	POST	prompts user for applicant record
//			which is read into Rec
void
Read_Rec(DataRec_T &Rec);void
Read_Rec(DataRec_T &Rec) {
	Club_T	Club;
	char		Response;

	cout	<<	"Number ==> ";
	cin	>>	Rec.Number;
	cout	<<	"Name ==> ";
	Rec.Name = Read_String();
	cout	<< "Date of application\n";
	Read_Date(Rec.Date);
	for (Club = FirstClub; Club <= LastClub; Club++) {
		cout	<<	"==> ";
		Write_Club(Club);
		cout	<< "  y/n ";
		cin	>>	Response;
		if (Response == 'y') {
			Set_Club(Club, Rec);
		}
		else {
			UnSet_Club(Club, Rec);
		}
	}
}



//	PRE	TRUE
//	POST	writes Rec to screen
void
Write_Rec(DataRec_T Rec) {

	cout	<<	"\nNumber is "
			<<	Rec.Number
			<< "\nName is "
			<<	Rec.Name
			<< "\nDate is ";
	Write_Date(Rec.Date);
	cout	<< "\nClubs are - ";
	Write_Clubs(Rec.Clubs);
}



// PRE	FileHandle is a correctly opened stream
// POST	IF record read from file OK THEN
//				returnS record read
//				Q_ValidRecFromFile' = TRUE
//			ELSE
//				Q_ValidRecFromFile' = FALSE
DataRec_T
Read_Rec_From_File(ifstream &InFile, BOOLEAN &Q_ValidRecFromFile) {
	DataRec_T Result;
	int	Club;

	Q_ValidRecFromFile = TRUE;
	if (!InFile.eof()) {
		InFile	>> Result.Number;
		if (!InFile.eof()) {
			Result.Name = Read_String_From_File(InFile, Q_ValidRecFromFile);
		}
		if (!InFile.eof()) {
			InFile	>> Result.Date.Day;
		}
		if (!InFile.eof()) {
			InFile	>> Result.Date.Month;
		}
		if (!InFile.eof()) {
			InFile	>> Result.Date.Year;
		}
		for(Club = 0; (Club < NumClubs) && (!InFile.eof()); Club++) {
			InFile	>> Result.Clubs[Club];
		}
	}
	else {
		// InFile.eof() does not become TRUE
		// until a read at the end of file is attempted
		// so if the procedure gets here then
		// this is a valid eof case
	}
	return(Result);
}


// PRE	FileHandle is a correctly opened stream
// POST	Rec written to FileHandle stream
void
Write_DataRec_To_File (DataRec_T Rec, ofstream &OutFile) {
	int	Club;

	OutFile	<<	Rec.Number
				<< "\n"
				<<	Rec.Name
				<< "\n"
				<<	Rec.Date.Day
				<< "\n"
				<<	Rec.Date.Month
				<< "\n"
				<<	Rec.Date.Year
				<< "\n";

	for(Club = 0; (Club < NumClubs); Club++) {
			OutFile	<< Rec.Clubs[Club];
	}
}


