// udt_arr.cpp
// 4/4/99
// Demo of user defined array types
// Ken Brownsey
#include <iostream.h>
#define MaxSize 5

typedef int IntArray_T[MaxSize];

// PRE	TRUE
// POST	prints out description of program and instructions
void
Instructions() {

	cout	<<	"\nThis program will prompt you for "
			<<	MaxSize
			<<	" integers"
			<<	"\nand will then print them back out again"
			<<	"\nthus demonstrating the use of arrays in C++\n\n";
}

// PRE	TRUE
// POST	prompts for and reads values into IntArray
void
Read_In_Values(IntArray_T IntArray) {
	int	Index;

	for(Index = 0; Index < MaxSize; Index++) {
		cout	<< "\nPlease type in an integer ==> ";
		cin	>> IntArray[Index];
	}
}


// PRE	TRUE
// POST	writes out values from IntArray
void
Print_Out_Values(IntArray_T IntArray) {
	int	Index;

	for(Index = 0; Index < MaxSize; Index++) {
		cout	<< "In position "
				// Note that C++ arrays start from 0
				// and we want to number from 1
				<< (Index + 1)
				<< " we have "
				<< IntArray[Index]
				<< "\n";
	}
}


void
main() {
	IntArray_T Nums;

	Instructions();
	Read_In_Values(Nums);
   cout	<< "\n\n********************\n\n";
	Print_Out_Values(Nums);
}


