// stu_rec.h
// 24/7/98
// Demo of types
// Ken Brownsey


typedef enum	Mode_T {FullTimeMod, PartTimeMod, FullTimeNonMod, PartTimeNonMod};

typedef int StuNum_T;
typedef char *Name_T;
typedef StuNum_T Key_T;

typedef struct {
	StuNum_T	StuNum;
	Name_T Name;
	enum 	Mode_T Mode;
} StudentRec_T;

typedef StudentRec_T DataRec_T;

// PRE	TRUE
// POST	user is prompted for student key value which is returned
Key_T
Read_Key();


// PRE	TRUE
// POST	key value is written to screen
void
Write_Key(Key_T Key);


// PRE	TRUE
// POST	RETURNS key value of DataRec
Key_T
Get_Key(DataRec_T	DataRec);


/*	PRE	TRUE */
/*	POST	prompts user for student record
			which is read into StRec */
void
Read_Rec(DataRec_T &DataRec);


/*	PRE	TRUE */
/*	POST	writes DataRec to screen */
void
Write_Rec(StudentRec_T DataRec);

