// searchdb.h
// 6/7/99
// Linear structure for demo of searching ordered and unordered sequence
// Ken Brownsey

#include "my_const.h"

typedef int	*SearchArray_T;

//	PRE	Hi >= Lo
//	POST	All values in positions [Lo..Hi]
//			are printed to screen
void
Print_Array_Interval(SearchArray_T DB, int Lo, int Hi);


//	PRE	Hi >= Lo
//	POST	All indices from Lo to Hi
//			are printed to screen
void
Print_Array_Indices(SearchArray_T DB, int Lo, int Hi);

//	PRE	MaxVal >= Size > 0
// POST	DB' is a sorted array of size Size
//			unique elements in range 1..MaxVal
void
Make_Ordered_RandomDB(SearchArray_T &DB, int	Size, int MaxVal);



