// ArcData.cpp
// 14/5/99
// arc records for Graph_T
// Ken Brownsey

#include "ArcData.h"
#include <iostream.h>
#include "rd_str.h"
#include <string.h>

// PRE	TRUE
// POST	user is prompted for arc key value which is returned
ArcKey_T
Read_ArcKey() {
	ArcKey_T ArcKey;

	cin	>>	ArcKey;
	return(ArcKey);
}


// PRE	TRUE
// POST	ArcKey value is written to screen
void
Write_ArcKey(ArcKey_T ArcKey) {

	cout	<< ArcKey;
}


// PRE	TRUE
// POST	returns key value of ArcDataRec
ArcKey_T
Get_ArcKey(ArcDataRec_T ArcDataRec) {

	return(ArcDataRec.Number);
}


// PRE	TRUE
// POST	Returns name of ArcDataRec
char
*Get_ArcName(ArcDataRec_T ArcDataRec) {

	return(ArcDataRec.Name);
}


// PRE	TRUE
// POST	returnS key value of source vertex in ArcDataRec
VertKey_T
Get_InitialVertKey(ArcDataRec_T ArcDataRec) {
	return(ArcDataRec.InitialVertKey);
}



// PRE	TRUE
// POST	returnS key value of sink vertex in ArcDataRec
VertKey_T
Get_FinalVertKey(ArcDataRec_T ArcDataRec)  {
	return(ArcDataRec.FinalVertKey);
}


//	PRE	TRUE
//	POST	prompts user for arc details
//			which are read into ArcDataRec
void
Read_ArcDataRec(ArcDataRec_T &ArcDataRec) {

	cout	<<	"Number ==> ";
	cin	>>	ArcDataRec.Number;
	cout	<<	"Name ==> ";
	ArcDataRec.Name = Read_String();
	cout	<<	"Initial vertex ==> ";
	ArcDataRec.InitialVertKey = Read_VertKey();
	cout	<<	"Final vertex ==> ";
	ArcDataRec.FinalVertKey = Read_VertKey();
}



//	PRE	TRUE
//	POST	writes ArcDataRec to screen
void
Write_ArcDataRec(ArcDataRec_T ArcDataRec) {

	cout	<<	"\nNumber is "
			<<	ArcDataRec.Number
			<< "\nName is "
			<<	ArcDataRec.Name
			<< "\nInitial vertex ";
	Write_VertKey(ArcDataRec.InitialVertKey);
	cout	<< "\nFinal vertex ";
	Write_VertKey(ArcDataRec.FinalVertKey);
}



// PRE	FileHandle is a correctly opened stream
// POST	IF record read from file OK THEN
//				returnS record read
//				Q_ValidRecFromFile' = TRUE
//			ELSE
//				Q_ValidRecFromFile' = FALSE
ArcDataRec_T
Read_ArcDataRec_From_File(ifstream &InFile, BOOLEAN &Q_ValidRecFromFile) {
	ArcDataRec_T Result;

	Q_ValidRecFromFile = TRUE;
	InFile	>> Result.Number;
	if (!InFile.eof()) {
		cout	<< "\n";
		cout	<< Result.Number;
		cout	<< " (a) ";
		Result.Name = Read_String_From_File(InFile, Q_ValidRecFromFile);
		if (!InFile.eof()) {
			cout	<< Result.Name;
		}
		else {
			Q_ValidRecFromFile = FALSE;
		}
		if (Q_ValidRecFromFile) {
			InFile	>> Result.InitialVertKey;
			if (!InFile.eof()) {
				cout	<< Result.InitialVertKey;
			}
			else {
				Q_ValidRecFromFile = FALSE;
			}
		}
		if (Q_ValidRecFromFile) {
			InFile	>> Result.FinalVertKey;
			if (!InFile.eof()) {
				cout	<< Result.FinalVertKey;
			}
			else {
				Q_ValidRecFromFile = FALSE;
			}
		}
	}
	return(Result);
}


// PRE	FileHandle is a correctly opened stream
// POST	ArcDataRec written to FileHandle stream
void
Write_ArcDataRec_To_File (ArcDataRec_T ArcDataRec, ofstream &OutFile) {

	OutFile	<<	ArcDataRec.Number
				<< "\n"
				<<	ArcDataRec.Name
				<< "\n";
}


