// vert.h
// 14/5/99
// Ken Brownsey
//	Vertex records for Graph_T
#ifndef	VERT_H
#define 	VERT_H

#include <fstream.h>
#include "my_const.h"

typedef int	VertKey_T;

typedef struct {
	VertKey_T	Number;
	char	*Name;
	void	*Arcs;
} VertRec_T;

// PRE	TRUE
// POST	user is prompted for student key value which is returned
VertKey_T
Read_VertKey();


// PRE	TRUE
// POST	key value is written to screen
void
Write_VertKey(VertKey_T VertKey);


// PRE	TRUE
// POST	returnS key value of VertRec
VertKey_T
Get_VertKey(VertRec_T VertRec);


//	PRE	TRUE
//	POST	prompts user for student record
//			which is read into VertRec
void
Read_VertRec(VertRec_T &VertRec);


//	PRE	TRUE
//	POST	writes VertRec to screen
void
Write_VertRec(VertRec_T VertRec);


// PRE	TRUE
//	POST	Arcs field of Rec set to NewArcs
//	NOTES	This allows programmer to insert first element into arcs
//			and is an implementation forced feature
void
Set_Arcs(VertRec_T VertRec, void	*NewArcs);


// PRE	FileHandle is a correctly opened stream
// POST	IF record read from file OK THEN
//				returnS record read
//				Q_ValidRecFromFile' = TRUE
//			ELSE
//				Q_ValidRecFromFile' = FALSE
VertRec_T
Read_VertRec_From_File(ifstream &InFile, BOOLEAN &Q_ValidRecFromFile);



// PRE	FileHandle is a correctly opened stream
// POST	VertRec written to FileHandle stream
void
Write_VertRec_To_File (VertRec_T VertRec, ofstream &OutFile);

#endif
