// data.cpp
// 24/7/98
// data for binary search tree demo
// Ken Brownsey

#include "data.h"
#include <iostream.h>
#include "rd_str.h"
#include <string.h>

// PRE	TRUE
// POST	user is prompted for student key value which is returned
Key_T
Read_Key() {
	Key_T Key;

	cin	>>	Key;
	return(Key);
}


// PRE	TRUE
// POST	key value is written to screen
void
Write_Key(Key_T Key) {

	cout	<< Key;
}


// PRE	TRUE
// POST	returnS key value of Rec
Key_T
Get_Key(DataRec_T DataRec) {

	return(DataRec.Number);
}


//	PRE	TRUE
//	POST	prompts user for student record
//			which is read into Rec
void
Read_Rec(DataRec_T &Rec) {

	cout	<<	"Number ==> ";
	cin	>>	Rec.Number;
	cout	<<	"Name ==> ";
	Rec.Name = Read_String();
}



//	PRE	TRUE
//	POST	writes Rec to screen
void
Write_Rec(DataRec_T Rec) {

	cout	<<	"\nNumber is "
			<<	Rec.Number
			<< "\nName is "
			<<	Rec.Name;
}


// PRE	TRUE
// POST	returnS Name value of Rec
char
*Get_Name(DataRec_T DataRec) {

	return(DataRec.Name);
}



// PRE	FileHandle is a correctly opened stream
// POST	IF record read from file OK THEN
//				returnS record read
//				Q_ValidRecFromFile' = TRUE
//			ELSE
//				Q_ValidRecFromFile' = FALSE
DataRec_T
Read_Rec_From_File(ifstream &InFile, BOOLEAN &Q_ValidRecFromFile) {
	DataRec_T Result;

	Q_ValidRecFromFile = TRUE;
	if (!InFile.eof()) {
		InFile	>> Result.Number;
		if (!InFile.eof()) {
			Result.Name = Read_String_From_File(InFile, Q_ValidRecFromFile);
			// if a string cannot be read because InFile.eof() will
			// become TRUE on the next read then the record is incomplete
			// i.e. invalid
		}
	}
	else {
		// InFile.eof() does not become TRUE
		// until a read at the end of file is attempted
		// so if the procedure gets here then
		// this is a valid eof case
	}
	return(Result);
}


// PRE	FileHandle is a correctly opened stream
// POST	Rec written to FileHandle stream
void
Write_DataRec_To_File (DataRec_T Rec, ofstream &OutFile) {

	OutFile	<<	Rec.Number
				<< "\n"
				<<	Rec.Name
				<< "\n";
}


