// Ken Brownsey
// 31/8/98
// bst_util.cpp
// BST_T utilities

#include "bst_util.h"
#include "rd_str.h"

typedef enum {LeftTurn, RightTurn} Turn_T;

typedef int Length_T;


// PRE	TRUE
// POST	Elements of BST are printed inorder
void
InOrder_R(BST_T BST) {
	if (!Q_EmptyTree(BST)) {
		InOrder_R(Get_Left(BST));
		Write_Rec(Get_DataRec(Get_Root(BST)));
		cout	<< "\n";
		InOrder_R(Get_Right(BST));
	}
}


// PRE TRUE
// POST RETURNS size of BST
int
Size_R(BST_T BST) {
	if (Q_EmptyTree(BST)) {
		return(0);
	}
	else {
		return(Size_R(Get_Left(BST)) + 1 + Size_R(Get_Right(BST)));
	}
}





